{ HDCTEST / 14.02.1987 }
{$C-,U-,r-,a-}
program hdctest;

const
{$i hdcdef.lib}

type
    str10 = string[10];
    wrkstring = string[80];

var
    hdcok     : boolean;
    ch        : char;
    Gap3_Len  : integer;
    Sekt_Size : integer;
    Buffer    : array[1..1024] of Byte;
    maxtrack  : integer;
    maxsek    : integer;
    errors    : integer;

{$i hdcrout.lib}

{ *** Ein Byte als HEX-Zahl ausgeben *** }
procedure WriteHex (b : byte);
var b1 : byte;
  procedure WriteNibble (b : byte);
  begin
    b := b + $30;
    if (b > $39) then b := b + 7;
    write (chr(b));
  end;
begin
  b1 := b shr 4;   WriteNibble(b1);
  b1 := b and $0F; WriteNibble(b1);
end;

{ *** Gebe b: integer als n-stellige Dualzahl aus *** }
procedure dispbit (b,n : integer);
var i,t : integer;
begin
  t := 1;
  for i := 1 to n do begin
    t := b shr (n-i);
    if (t and 1) = 1 then write ('1') else write ('0');
  end;
end;

{ *** Auf Eingabe warten, W = Wait, G = go *** }
procedure waitkey;
var ch1,ch2 : char;
begin
  if keypressed then begin
    read(kbd,ch1);
    if upcase(ch1) = 'W' then begin
      repeat
        read(kbd,ch2);
      until (upcase(ch2) = 'G');
    end;
  end;
end;

{ *** Erster Speichertest *** }
function checkpatram(seklen : integer) : boolean;
var i,d    : integer;
    s,ok,f : boolean;
    pat    : byte;
    ch     : char;
begin
  write(' Testing Buffer-Ram with Pattern ...');
  ok  := true;
  f   := true;
  pat := 0;
  repeat
    for i :=1 to seklen do port[hdcdata] := pat;
    s := true;
    for i := 1 to seklen do begin
      d := port[hdcdata];
      s := s and (d = Pat);
      if not s then ok := s;
    end;
    if not s then begin
      if f then begin writeln; f := false; end;
      write('Buffer Error : Pattern = ');WriteHex(pat);
      write(' = ');dispbit(pat,8);write(' -> Data = ');
      WriteHex (d);write(' = ');dispbit(d,8);writeln;
      waitkey;
    end;
    pat := pat + 1;
  until (pat>255) or (not s) or keypressed;
  if keypressed then read(kbd,ch);
  if ok then writeln('Buffer is OK') else writeln('Buffer is not OK');
  checkpatram := ok;
end;

{ *** Zweiter Speichertest *** }
function checkadrram (seklen : integer) : boolean;
var i        : integer;
    d        : byte;
    ok,first : boolean;
begin
  writeln;
  write(' Testing Buffer-Ram with Adress-Data ...');
  for i := 1 to seklen do port[hdcdata] := lo(i);
  ok := true;
  for i := 1 to seklen do begin
    d := port[hdcdata];
    ok := ok and (d = lo(i));
    if (d<> lo(i)) then begin
      if first then begin
        writeln;
        first := false;
      end;
      write(' Adress = ');writehex(hi(i));writehex(lo(i));
      write(' Data = ');writehex(lo(i));write(' -> ');writehex(lo(d));
      writeln;
    end;
  end;
  if ok then writeln('Buffer is OK') else writeln('Buffer is not OK');
  checkadrram := ok;
end;

{ *** SDH-Register setzen *** }
procedure setsdh(drv,head,seklen : integer);
var i,s : integer;
begin
  i := (head and(Anzahl_Koepfe-1));
  i := i or ((drv and $03) shl 3);
  case seklen of
    128  : s := $60;
    256  : s := $00;
    512  : s := $20;
    1024 : s := $40;
    else begin
      writeln(' Internal Error : Sektorlength incorrect');
    end;
  end;
  i := i or s or 8;
  port[hdcsdh] := i;
  if port[hdcsdh] <> i then begin
    writeln;
    write('Error : SDH-Register incorrect : ',i:3,' --> ');
    writehex(port[hdcsdh]);
    writeln;
    end
  else
    begin
    writeln;
    writeln(' SDH-Register OK ');
    writeln;
    end;
  end;

{ *** Seek-Test *** }
function seektest (nt : integer) : boolean;
var i,j,k : integer;
    ok    : boolean;
    st    : byte;
    ch    : char;
begin
  writeln;
  write(' Seek-Test (10 Restore-Seeks) ... ');
  k := 0;
  repeat
    k := k+1;
    HDC_Wait;
    HDC_Home;
    HDC_Wait;
    st := port[hdcstat];
    if ((st and 1) <> 0) then begin
      ok := false;
      st := port[hdcerr];
      writeln;
      write('Restore failed, Error Code = ',st:2);
    end else begin
      port[hdccyl] := lo(nt);
      port[hdccyh] := hi(nt);
      port[hdccmd] := Seek_CMD;
      HDC_Wait;
      st := port[hdcstat];
      if ((st and 1) <> 0) then begin
        st := port[hdcerr];
        writeln;
        writeln('Seek failed, Error Code = ',st:2);
        ok := false;
      end else begin
        write(' + ');
        st := port[hdcstat];
        if ((st and 1) <> 0) then begin
          write('Seek to Track 0 failed, Error Code = ');writehex(st);
          writeln;
          ok := false;
        end else ok := true;
      end;
    end;
  until (k>10) or keypressed;
  if keypressed then read(kbd,ch);
  if ok then writeln(' Seek-Test OK');
  seektest := ok;
end;

{ *** Disk-Read-Test *** }
function scanid(tr : integer) : boolean;
var j,i : integer;
    ok  : boolean;
begin
  ok := true;
  writeln;
  write(' Disk Read-Test ... ');
  port[hdccyl] := lo(tr);
  port[hdccyh] := hi(tr);
  port[hdcsek] := 1;
  port[hdccmd] := Seek_CMD;
  j := 0;
  while (not keypressed) and (j=0) do begin
    HDC_Wait;
    port[hdccmd] := Scanid_Fast_CMD;
    HDC_Wait;
    i := port[hdcstat];
    if (i and 1)=1 then begin;
      j := port[hdcerr];
      ok := false;
    end else begin
      j := 0;
    end;
  end;
  if ok then
    writeln(' Disk Read-Test OK')
  else
    begin
    writeln(' Error: Disk Read-Test');
    writeln;
    write(' Error = ');writehex(j);writeln;
    i := port[hdcstat];
    write(' Status = ');writehex(i);writeln;
    i := port[hdccyh]*256 + port[hdccyl];
    writeln(' Track = ',i);
    i := port[hdcsek];
    writeln(' Sektor = ',i);
    end;
  scanid := ok;
end;

{ *** MAIN *** }
begin
  clrscr;
  writeln('Miniscribe-Testroutinen fuer HD - Controller v1.0 - 14.02.1987');
  writeln;
  HDC_Init;
  writeln('Alle Tests koennen mit einem Tastendruck beendet werden.');
  writeln;
  setsdh(0,0,Sektor_Laenge);
  hdcok := checkpatram(2048);
  hdcok := hdcok and checkadrram(2048);
  hdcok := hdcok and seektest(Anzahl_Zylinder);
  hdcok := hdcok and scanid(10);
  writeln;
  if hdcok then writeln('Controller ist OK und soweit funktionsbereit!')
           else writeln('HDC-Karte ist fehlerhaft!');
  writeln;
  writeln('Test beendet.');
  HDC_deselect;
end.
